<?php

	// Perform Login
    $SHORTCODE_STATUS = PHPCUS_SHORTCODE::CUS_QUICK_LOGIN();
	
	// Check Array Input
	PHPCUS_PARAM::CUS_DOES_NOT_SUPPORT_ARRAY();
	
	// Check already authenticated
	PHPCUS_PARAM::CUS_REQUIRES_AUTHENTICATION();
	// Check access rights
	PHPCUS_PARAM::CUS_HAS_PERMISSION(PHPCUS_SYSTEM::AUTHORITY_VIEW_ONLY, 'record_voucher');
	
	if
	(
		PHPRC_HTTP_PARAM::REF_ISSET_IN_ARRAY
		(
			[
					'PARAM_REC_VOUCHER_ID',
					'PARAM_REC_VOUCHER_CODE',
					'PARAM_REC_VOUCHER_IS_VOUCHER_FROM',
					'PARAM_REC_VOUCHER_IS_VOUCHER_TO',
					'PARAM_REC_VOUCHER_CAT_DISCOUNT_ID',
					'PARAM_REC_VOUCHER_AMOUNT_FROM',
					'PARAM_REC_VOUCHER_AMOUNT_TO',
					'PARAM_REC_VOUCHER_DATE_BEGIN_FROM',
					'PARAM_REC_VOUCHER_DATE_BEGIN_TO',
					'PARAM_REC_VOUCHER_DATE_END_FROM',
					'PARAM_REC_VOUCHER_DATE_END_TO',
					'PARAM_REC_VOUCHER_IS_UNLIMITED',
					'PARAM_REC_VOUCHER_STATUS',
					'PARAM_REC_VOUCHER_SYSTEM_GENERATED',
					
					'PARAM_ORDER_FIELD',
					'PARAM_ORDER_TYPE',
					'PARAM_SKIP',
					'PARAM_LIMIT'
			], True
		)
	)
	{
		Try
		{
			// Read params
			// ------------------------------------------------------------------	
			$PARAM_REC_VOUCHER_ID = PHPCUS_PARAM::CUS_READ_BIGINT('PARAM_REC_VOUCHER_ID');
			$PARAM_REC_VOUCHER_CODE = PHPCUS_PARAM::CUS_READ_NVARCHAR('PARAM_REC_VOUCHER_CODE');
			$PARAM_REC_VOUCHER_IS_VOUCHER_FROM = PHPCUS_PARAM::CUS_READ_INT('PARAM_REC_VOUCHER_IS_VOUCHER_FROM');
			$PARAM_REC_VOUCHER_IS_VOUCHER_TO = PHPCUS_PARAM::CUS_READ_INT('PARAM_REC_VOUCHER_IS_VOUCHER_TO');
			$PARAM_REC_VOUCHER_CAT_DISCOUNT_ID = PHPCUS_PARAM::CUS_READ_BIGINT('PARAM_REC_VOUCHER_CAT_DISCOUNT_ID');
			$PARAM_REC_VOUCHER_AMOUNT_FROM = PHPCUS_PARAM::CUS_READ_DECIMAL('PARAM_REC_VOUCHER_AMOUNT_FROM');
			$PARAM_REC_VOUCHER_AMOUNT_TO = PHPCUS_PARAM::CUS_READ_DECIMAL('PARAM_REC_VOUCHER_AMOUNT_TO');
			$PARAM_REC_VOUCHER_DATE_BEGIN_FROM = PHPCUS_PARAM::CUS_READ_DATETIME('PARAM_REC_VOUCHER_DATE_BEGIN_FROM');
			$PARAM_REC_VOUCHER_DATE_BEGIN_TO = PHPCUS_PARAM::CUS_READ_DATETIME('PARAM_REC_VOUCHER_DATE_BEGIN_TO');
			$PARAM_REC_VOUCHER_DATE_END_FROM = PHPCUS_PARAM::CUS_READ_DATETIME('PARAM_REC_VOUCHER_DATE_END_FROM');
			$PARAM_REC_VOUCHER_DATE_END_TO = PHPCUS_PARAM::CUS_READ_DATETIME('PARAM_REC_VOUCHER_DATE_END_TO');
			$PARAM_REC_VOUCHER_IS_UNLIMITED = PHPCUS_PARAM::CUS_READ_INT('PARAM_REC_VOUCHER_IS_UNLIMITED');
			$PARAM_REC_VOUCHER_STATUS = PHPCUS_PARAM::CUS_READ_INT('PARAM_REC_VOUCHER_STATUS');
			$PARAM_REC_VOUCHER_SYSTEM_GENERATED = PHPCUS_PARAM::CUS_READ_INT('PARAM_REC_VOUCHER_SYSTEM_GENERATED');
			
			$PARAM_ORDER_FIELD = PHPCUS_PARAM::CUS_READ_SORT_FIELD
			(
					'PARAM_ORDER_FIELD',
					[
						'REC_VOUCHER_ID', 
						'REC_VOUCHER_CODE', 
						'REC_VOUCHER_IS_VOUCHER', 
						'REC_VOUCHER_CAT_DISCOUNT_ID', 
						'REC_VOUCHER_AMOUNT', 
						'REC_VOUCHER_DATE_BEGIN', 
						'REC_VOUCHER_DATE_END', 
						'REC_VOUCHER_IS_UNLIMITED', 
						'REC_VOUCHER_STATUS', 
						'REC_VOUCHER_SYSTEM_GENERATED'
						, 
						'CAT_DISCOUNT_ID',		
						'CAT_DISCOUNT_DESCRIPTION',		
						'CAT_DISCOUNT_PERCENTAGE',		
						'CAT_DISCOUNT_AMOUNT',		
						'CAT_DISCOUNT_VAT',		
						'CAT_DISCOUNT_HAS_POINT',		
						'CAT_DISCOUNT_CHANGE_TAX_TYPE',		
						'CAT_DISCOUNT_CAT_TAXMODEL_ID',		
						'CAT_DISCOUNT_REMARKS',		
						'CAT_DISCOUNT_STATUS',		
						'CAT_DISCOUNT_SYSTEM_GENERATED'		
					]
			);		
			$PARAM_ORDER_TYPE = PHPCUS_PARAM::CUS_READ_SORT_TYPE('PARAM_ORDER_TYPE');
			$PARAM_SKIP	= PHPCUS_PARAM::CUS_READ_BIGINT('PARAM_SKIP');
			$PARAM_LIMIT = PHPCUS_PARAM::CUS_READ_BIGINT('PARAM_LIMIT');
			
			// ------------------------------------------------------------------
			
			
			// Populate Map Array
			// ...........................................
			$GET_MAP_ARRAY = PHPCUS_RECORD_VOUCHER::CUS_PREPARE_MAPPED_ARRAY_FOR_GET();
			
			$GET_MAP_ARRAY['PARAM_REC_VOUCHER_ID'] = $PARAM_REC_VOUCHER_ID;
			$GET_MAP_ARRAY['PARAM_REC_VOUCHER_CODE'] = $PARAM_REC_VOUCHER_CODE;
			$GET_MAP_ARRAY['PARAM_REC_VOUCHER_IS_VOUCHER_FROM'] = $PARAM_REC_VOUCHER_IS_VOUCHER_FROM;
			$GET_MAP_ARRAY['PARAM_REC_VOUCHER_IS_VOUCHER_TO'] = $PARAM_REC_VOUCHER_IS_VOUCHER_TO;
			$GET_MAP_ARRAY['PARAM_REC_VOUCHER_CAT_DISCOUNT_ID'] = $PARAM_REC_VOUCHER_CAT_DISCOUNT_ID;
			$GET_MAP_ARRAY['PARAM_REC_VOUCHER_AMOUNT_FROM'] = $PARAM_REC_VOUCHER_AMOUNT_FROM;
			$GET_MAP_ARRAY['PARAM_REC_VOUCHER_AMOUNT_TO'] = $PARAM_REC_VOUCHER_AMOUNT_TO;
			$GET_MAP_ARRAY['PARAM_REC_VOUCHER_DATE_BEGIN_FROM'] = $PARAM_REC_VOUCHER_DATE_BEGIN_FROM;
			$GET_MAP_ARRAY['PARAM_REC_VOUCHER_DATE_BEGIN_TO'] = $PARAM_REC_VOUCHER_DATE_BEGIN_TO;
			$GET_MAP_ARRAY['PARAM_REC_VOUCHER_DATE_END_FROM'] = $PARAM_REC_VOUCHER_DATE_END_FROM;
			$GET_MAP_ARRAY['PARAM_REC_VOUCHER_DATE_END_TO'] = $PARAM_REC_VOUCHER_DATE_END_TO;
			$GET_MAP_ARRAY['PARAM_REC_VOUCHER_IS_UNLIMITED'] = $PARAM_REC_VOUCHER_IS_UNLIMITED;
			$GET_MAP_ARRAY['PARAM_REC_VOUCHER_STATUS'] = $PARAM_REC_VOUCHER_STATUS;
			$GET_MAP_ARRAY['PARAM_REC_VOUCHER_SYSTEM_GENERATED'] = $PARAM_REC_VOUCHER_SYSTEM_GENERATED;
			
			$GET_MAP_ARRAY["PARAM_ORDER_FIELD"] = $PARAM_ORDER_FIELD;
			$GET_MAP_ARRAY["PARAM_ORDER_TYPE"] = $PARAM_ORDER_TYPE;
			$GET_MAP_ARRAY["PARAM_SKIP"] = $PARAM_SKIP;
			$GET_MAP_ARRAY["PARAM_LIMIT"] = $PARAM_LIMIT;
			
			
			// Execute Stored Procedure
			// ...........................................
			$DATA_SET = PHPCUS_RECORD_VOUCHER::CUS_GET_MA($GET_MAP_ARRAY);
			
						
			// Return JSON response
			// ...........................................
			if(empty($DATA_SET) === False)
			{
				PHPCUS_PARAM::CUS_JSON_SUCCESS($DATA_SET);
			}
			else
			{
				PHPCUS_PARAM::CUS_JSON_SUCCESS('');
			}
			
		}
		Catch(Exception $ERR)
		{		
			PHPVC_LOG::VAR_REPORT_ERROR($ERR, 0);
			if(isset($_SERVER['HTTP_ORIGIN']))
			{
			    PHPVC_LOG::VAR_ERROR('HTTP_ORIGIN', $_SERVER['HTTP_ORIGIN']);
			}
			if(isset($_SERVER['HTTP_HOST']))
			{
			    PHPVC_LOG::VAR_ERROR('HTTP_HOST', $_SERVER['HTTP_HOST']);
			}		
			if(isset($_SERVER['HTTP_REFERER']))
			{
			    PHPVC_LOG::VAR_ERROR('HTTP_REFERER', $_SERVER['HTTP_REFERER']);
			}
			if(isset($_SERVER['REMOTE_ADDR']))
			{
			    PHPVC_LOG::VAR_ERROR('REMOTE_ADDR', $_SERVER['REMOTE_ADDR']);
			}
			
			PHPCUS_PARAM::CUS_JSON_ERROR($ERR->getMessage());
		}
	}
	else
	{
		PHPCUS_PARAM::CUS_JSON_ERROR('Missing parameters');
	}

?>